package q1k2.base.common.ceco.model;

import org.apache.poi.ss.usermodel.Cell;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.model
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  17:50
 * @Description: TODO
 * @Version: 1.0
 */
public class ExcelCellInfo {
    private int columnIndex;
    private String baseDataKey;
    private String entryKey;
    private String fieldKey;
    private String cellOldValue;

    ExcelCellInfo(Cell cell) {
        if (cell != null) {
            this.columnIndex = cell.getColumnIndex();
            this.cellOldValue = cell.getStringCellValue();
            if (this.cellOldValue.startsWith("{") && this.cellOldValue.endsWith("}")) {
                String cellValue = this.cellOldValue.substring(1, this.cellOldValue.length() - 1);
                if (cellValue.contains(".")) {
                    this.baseDataKey = cellValue.split("\\.")[0];
                    this.fieldKey = cellValue.split("\\.")[1];
                } else if (cellValue.contains(":")) {
                    this.entryKey = cellValue.split(":")[0];
                    this.fieldKey = cellValue.split(":")[1];
                } else {
                    this.fieldKey = cellValue;
                }
            } else {
                this.baseDataKey = "";
                this.entryKey = "";
                this.fieldKey = "";
            }

        }
    }

    public int getColumnIndex() {
        return this.columnIndex;
    }

    public void setColumnIndex(int columnIndex) {
        this.columnIndex = columnIndex;
    }

    public String getBaseDataKey() {
        return this.baseDataKey;
    }

    public void setBaseDataKey(String baseDataKey) {
        this.baseDataKey = baseDataKey;
    }

    public String getEntryKey() {
        return this.entryKey;
    }

    public void setEntryKey(String entryKey) {
        this.entryKey = entryKey;
    }

    public String getFieldKey() {
        return this.fieldKey;
    }

    public void setFieldKey(String fieldKey) {
        this.fieldKey = fieldKey;
    }

    public String getCellOldValue() {
        return this.cellOldValue;
    }

    public void setCellOldValue(String cellOldValue) {
        this.cellOldValue = cellOldValue;
    }
}
