package q1k2.base.common.ceco.model;

import kd.bos.util.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.model
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  17:51
 * @Description: TODO
 * @Version: 1.0
 */
public class ExcelRowInfo {
    private Row row;
    private String entryKey;
    private List<ExcelCellInfo> cellList;

    public ExcelRowInfo(Row row) {
        if (row != null) {
            this.row = row;

            ExcelCellInfo cellInfo;
            for(Iterator var2 = this.row.iterator(); var2.hasNext(); this.addCellList(cellInfo)) {
                Cell cell = (Cell)var2.next();
                cellInfo = new ExcelCellInfo(cell);
                if (!StringUtils.isEmpty(cellInfo.getEntryKey()) && StringUtils.isEmpty(this.getEntryKey())) {
                    this.setEntryKey(cellInfo.getEntryKey());
                }
            }

        }
    }

    public Row getRow() {
        return this.row;
    }

    public void setRow(Row row) {
        this.row = row;
    }

    public String getEntryKey() {
        return this.entryKey;
    }

    public void setEntryKey(String entryKey) {
        this.entryKey = entryKey;
    }

    public List<ExcelCellInfo> getCellList() {
        return this.cellList;
    }

    public void addCellList(ExcelCellInfo cellInfo) {
        if (this.cellList == null) {
            this.cellList = new ArrayList();
        }

        this.cellList.add(cellInfo);
    }

    public void setCellList(List<ExcelCellInfo> cellList) {
        this.cellList = cellList;
    }
}
