package q1k2.base.common.ceco.model.xmlfilemodel;

import kd.bos.util.StringUtils;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import q1k2.base.common.ceco.helper.XMLFileHelper;

import java.io.IOException;
import java.util.List;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.model.xmlfilemodel
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  18:11
 * @Description: TODO
 * @Version: 1.0
 */
public class KdpkgsXmlFileInfo {
    private String kdpkgsFileName;
    private XMLFileHelper kdpkgsFile;

    public KdpkgsXmlFileInfo(String kdpkgsFileName) throws DocumentException, IOException {
        this.kdpkgsFileName = kdpkgsFileName;
        if (!StringUtils.isEmpty(kdpkgsFileName)) {
            this.kdpkgsFile = new XMLFileHelper(this.kdpkgsFileName);
        }
    }

    public Element getElement(String elementKeys) {
        return this.kdpkgsFile.getElement(elementKeys);
    }

    public List<Element> getElements(String elementKeys) {
        return this.kdpkgsFile.getElements(elementKeys);
    }

    public String getVersion() {
        return this.kdpkgsFile.getAttributeValue("ver");
    }

    public String getIsvCode() {
        return this.kdpkgsFile.getAttributeValue("isv");
    }

    public String getReleasetime() {
        String releaseTime = this.kdpkgsFile.getAttributeValue("releaseTime");
        if (!StringUtils.isEmpty(releaseTime) && !releaseTime.contains("-") && !releaseTime.contains(":") && releaseTime.length() == 8) {
            releaseTime = String.format("%s-%s-%s 00:00:00", releaseTime.substring(0, 4), releaseTime.substring(4, 6), releaseTime.substring(6, 8));
        }

        return releaseTime;
    }

    public Element getElementFromID(List<Element> kdpkgElements, String idValue) {
        return this.kdpkgsFile.getElementFromID(kdpkgElements, idValue);
    }

    public String getKdpkgsFileName() {
        return this.kdpkgsFileName;
    }

    public void setKdpkgsFileName(String kdpkgsFileName) {
        this.kdpkgsFileName = kdpkgsFileName;
    }
}
