package q1k2.base.common.ceco.model.xmlfilemodel;

import kd.bos.util.StringUtils;
import org.dom4j.DocumentException;
import q1k2.base.common.ceco.helper.XMLFileHelper;
import q1k2.base.common.ceco.model.ScheduleInfo;

import java.io.IOException;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.model.xmlfilemodel
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  18:12
 * @Description: TODO
 * @Version: 1.0
 */
public class ScheduleXmlFileInfo {
    private String dmZipFile;
    private String filePath;
    private String fileName;
    private XMLFileHelper metadata;

    public ScheduleXmlFileInfo(String dmZipFile, String filePath, String fileName) throws DocumentException, IOException {
        this.dmZipFile = dmZipFile;
        this.filePath = filePath;
        this.fileName = fileName;
        if (!StringUtils.isEmpty(filePath) && !StringUtils.isEmpty(fileName)) {
            this.metadata = new XMLFileHelper(this.filePath + this.fileName);
        }

    }

    public ScheduleInfo getScheduleInfo() {
        if (this.metadata == null) {
            return null;
        } else {
            ScheduleInfo scheduleInfo = new ScheduleInfo();
            scheduleInfo.setDmzip(this.dmZipFile);
            scheduleInfo.setNumber(this.metadata.getElementStringValue("ScheduleMainEntity.ScheduleMainEntity.Number"));
            scheduleInfo.setName(this.metadata.getElementStringValue("ScheduleMainEntity.ScheduleMainEntity.Name"));
            scheduleInfo.setStartTime(this.metadata.getElementLongValue("ScheduleMainEntity.ScheduleMainEntity.StartTime"));
            scheduleInfo.setEndTime(this.metadata.getElementLongValue("ScheduleMainEntity.ScheduleMainEntity.EndTime"));
            scheduleInfo.setEnable(this.metadata.getElementBooleanValue(this.metadata.getElement("ScheduleMainEntity.ScheduleMainEntity"), "Name"));
            scheduleInfo.setRepeatmode(this.metadata.getElementStringValue("ScheduleMainEntity.ScheduleMainEntity.RepeatMode"));
            scheduleInfo.setCron(this.metadata.getElementStringValue("ScheduleMainEntity.ScheduleMainEntity.Cron"));
            return scheduleInfo;
        }
    }
}
