package q1k2.base.common.ceco.model.xmlfilemodel;

import kd.bos.util.StringUtils;
import org.dom4j.DocumentException;
import q1k2.base.common.ceco.helper.XMLFileHelper;
import q1k2.base.common.ceco.model.WriteBackRuleInfo;

import java.io.IOException;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.model.xmlfilemodel
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  18:14
 * @Description: TODO
 * @Version: 1.0
 */
public class WriteBackRuleXmlFileInfo {
    private String dmZipFile;
    private String filePath;
    private String fileName;
    private XMLFileHelper metadata;

    public WriteBackRuleXmlFileInfo(String dmZipFile, String filePath, String fileName) throws DocumentException, IOException {
        this.dmZipFile = dmZipFile;
        this.filePath = filePath;
        this.fileName = fileName;
        if (!StringUtils.isEmpty(filePath) && !StringUtils.isEmpty(fileName)) {
            this.metadata = new XMLFileHelper(this.filePath + this.fileName);
        }

    }

    public WriteBackRuleInfo getWriteBackRuleInfo() {
        if (this.metadata == null) {
            return null;
        } else {
            WriteBackRuleInfo writeBackRuleInfo = new WriteBackRuleInfo();
            writeBackRuleInfo.setDmzip(this.dmZipFile);
            writeBackRuleInfo.setID(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.DataXml.WriteBackRuleMetadata.Id"));
            writeBackRuleInfo.setName(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.DataXml.WriteBackRuleMetadata.Name"));
            writeBackRuleInfo.setSourceEntityNumber(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.SourceEntityNumber"));
            writeBackRuleInfo.setTargetEntityNumber(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.TargetEntityNumber"));
            writeBackRuleInfo.setDevType(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.DevType"));
            writeBackRuleInfo.setIsv(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.Isv"));
            writeBackRuleInfo.setSysStatus(this.metadata.getElementStringValue("DesignMetas.DesignWriteBackRuleMeta.SysStatus"));
            return writeBackRuleInfo;
        }
    }
}
