package q1k2.base.common.ceco.plugin.formplugin;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.db.DB;
import kd.bos.db.DBRoute;
import kd.bos.db.FieldInfo;
import kd.bos.db.IndexInfo;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IPageCache;
import kd.bos.form.ShowType;
import kd.bos.form.control.Button;
import kd.bos.form.control.CodeEdit;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.ComboEdit;
import kd.bos.form.field.ComboItem;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.metadata.dao.MetaCategory;
import kd.bos.metadata.dao.MetadataDao;
import kd.bos.newdevportal.table.ErDataGenerator;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.ISVServiceHelper;
import kd.sdk.plugin.Plugin;
import q1k2.base.common.ceco.enums.SystemFieldEnum;
import q1k2.base.common.ceco.model.TableInfo;
import q1k2.base.common.utils.MetadataUtil;

import java.util.*;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.plugin.formplugin
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  18:21
 * @Description: TODO
 * @Version: 1.0
 */
public class TableStructureToKsqlFormPlugin extends AbstractFormPlugin implements Plugin {
    private static final String BTN_TOKSQL = "btn_toksql";
    private static final String BTN_ADDCOLUMN_TOKSQL = "btn_addcolumn_toksql";
    private static final String BTN_KSQLTRANS = "btn_ksqltrans";
    private static final String FIELD_FORMOBJECT = "formobject";
    private static final String FIELD_FORMOBJECTLIST = "formobjectlist";
    private static final String FIELD_APPOBJECT = "appobject";
    private static final String FIELD_ISVCODE = "isvcode";
    private static final String FIELD_FORMTABLES = "formtables";
    private static final String FIELD_TABLEFIELDS = "tablefields";

    public TableStructureToKsqlFormPlugin() {
    }

    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btn_toksql", "btn_addcolumn_toksql", "btn_ksqltrans"});
        BasedataEdit appobject = (BasedataEdit)this.getControl("appobject");
        appobject.addBeforeF7SelectListener((o) -> {
            ListShowParameter parameter = (ListShowParameter)o.getFormShowParameter();
            if (!ISVServiceHelper.isKingdeeISV()) {
                QFilter qFilter = new QFilter("isv", "=", ISVServiceHelper.getISVInfo().getId());
                parameter.getListFilterParameter().setFilter(qFilter);
            }

        });
        if (this.getModel().getValue("appobject") != null) {
            DynamicObject appDym = (DynamicObject)this.getModel().getValue("appobject");
            String appId = appDym.getString("id");
            BasedataEdit formobjectlist = (BasedataEdit)this.getControl("formobjectlist");
            formobjectlist.addBeforeF7SelectListener((o) -> {
                ListShowParameter parameter = (ListShowParameter)o.getFormShowParameter();
                List<String> filterModelType = new ArrayList();
                filterModelType.add("BillFormModel");
                filterModelType.add("BaseFormModel");
                QFilter qFilter = new QFilter("modeltype", "in", filterModelType);
                qFilter.and(new QFilter("bizappid", "=", appId));
                if (!ISVServiceHelper.isKingdeeISV()) {
                    qFilter.and(new QFilter("isv", "=", ISVServiceHelper.getISVInfo().getId()));
                    qFilter.and(new QFilter("type", "!=", "2"));
                    List<String> medataIds = new ArrayList();
                    QFilter qf = new QFilter("modeltype", "in", filterModelType);
                    qf.and(new QFilter("isv", "=", ISVServiceHelper.getISVInfo().getId()));
                    qf.and(new QFilter("type", "=", "2"));
                    DynamicObject[] ids = BusinessDataServiceHelper.load("bos_formmeta", "masterid", qf.toArray());
                    DynamicObject[] var8 = ids;
                    int var9 = ids.length;

                    for(int var10 = 0; var10 < var9; ++var10) {
                        DynamicObject obj = var8[var10];
                        String mid = obj.getString("masterid");
                        medataIds.add(mid);
                    }

                    if (medataIds.size() > 0) {
                        qFilter.or("id", "in", medataIds);
                    }
                }

                parameter.getListFilterParameter().setFilter(qFilter);
            });
        }

        BasedataEdit formObject = (BasedataEdit)this.getControl("formobject");
        formObject.addBeforeF7SelectListener((o) -> {
            ListShowParameter parameter = (ListShowParameter)o.getFormShowParameter();
            List<String> filterModelType = new ArrayList();
            filterModelType.add("BillFormModel");
            filterModelType.add("BaseFormModel");
            QFilter qFilter = new QFilter("modeltype", "in", filterModelType);
            if (!ISVServiceHelper.isKingdeeISV()) {
                qFilter.and(new QFilter("isv", "=", ISVServiceHelper.getISVInfo().getId()));
                qFilter.and(new QFilter("type", "!=", "2"));
                List<String> medataIds = new ArrayList();
                QFilter qf = new QFilter("modeltype", "in", filterModelType);
                qf.and(new QFilter("isv", "=", ISVServiceHelper.getISVInfo().getId()));
                qf.and(new QFilter("type", "=", "2"));
                DynamicObject[] ids = BusinessDataServiceHelper.load("bos_formmeta", "masterid", qf.toArray());
                DynamicObject[] var7 = ids;
                int var8 = ids.length;

                for(int var9 = 0; var9 < var8; ++var9) {
                    DynamicObject obj = var7[var9];
                    String mid = obj.getString("masterid");
                    medataIds.add(mid);
                }

                if (medataIds.size() > 0) {
                    qFilter.or("id", "in", medataIds);
                }
            }

            parameter.getListFilterParameter().setFilter(qFilter);
        });
    }

    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        this.getModel().setValue("isvcode", ISVServiceHelper.getISVInfo().getId());
        this.getView().updateView("isvcode");
    }

    public void click(EventObject evt) {
        super.click(evt);
        String controlName = "";
        if (evt.getSource() instanceof Button) {
            controlName = ((Button)evt.getSource()).getKey();
        }

        switch (controlName) {
            case "btn_toksql":
                this.createKSQL_FormOjbList();
                break;
            case "btn_addcolumn_toksql":
                this.createKSQL_AddField();
                break;
            case "btn_ksqltrans":
                this.ksqlTrans();
        }

    }

    private void ksqlTrans() {
        CodeEdit codeSQLshow = (CodeEdit)this.getView().getControl("ksqltext");
        String ksqlStr = codeSQLshow.getText();
        if (StringUtils.isEmpty(ksqlStr)) {
            this.getView().showTipNotification("没有可翻译的KSQL");
        } else {
            FormShowParameter formShowParameter = new FormShowParameter();
            formShowParameter.getOpenStyle().setShowType(ShowType.Modal);
            formShowParameter.setFormId("bos_frame_ksqltrans");
            Map<String, Object> custMap = new HashMap();
            custMap.put("ksqlStr", ksqlStr);
            formShowParameter.setCustomParams(custMap);
            formShowParameter.addCustPlugin("q1k2.base.common.ceco.plugin.formplugin.KSQLTransFormPlugin");
            this.getView().showForm(formShowParameter);
        }
    }

    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        switch (e.getProperty().getName()) {
            case "formobject":
                this.propertyChanged_FormObj();
                break;
            case "formtables":
                this.propertyChanged_FormTalbe();
                break;
            case "appobject":
                this.propertyChanged_AppOjb();
        }

    }

    private void createKSQL_AddField() {
        String addTableName = (String)this.getModel().getValue("formtables");
        String addTableFields = (String)this.getModel().getValue("tablefields");
        if (!StringUtils.isEmpty(addTableName) && !StringUtils.isEmpty(addTableFields)) {
            this.createKSQL(addTableName, addTableFields);
        } else {
            this.getView().showErrorNotification("请选择需要生成增加字段KSQL的表，以及字段信息");
        }
    }

    private void propertyChanged_FormTalbe() {
        ComboEdit combo_Field = (ComboEdit)this.getControl("tablefields");
        List<ComboItem> items = new ArrayList();
        combo_Field.setComboItems(items);
        this.getModel().setValue("tablefields", "");
        String tableName = (String)this.getModel().getValue("formtables");
        if (!StringUtils.isEmpty(tableName)) {
            DynamicObject dym = (DynamicObject)this.getModel().getValue("formobject");
            String formNumber = dym.getString("number");
            String dbRoutKey = MetadataUtil.getDBRoutKeyByFormNumber(formNumber);
            String entityId = MetadataDao.getIdByNumber(formNumber, MetaCategory.Entity);
            String data = ErDataGenerator.getErdData(entityId, formNumber, dbRoutKey, "", (IPageCache)null);
            if (!StringUtils.isEmpty(data)) {
                JSONObject dataJson = JSONObject.parseObject(data);
                JSONArray tableArray = dataJson.getJSONObject("table").getJSONArray("tables");
                List<JSONObject> tableInfos = (List) SerializationUtils.fromJsonString(tableArray.toJSONString(), List.class);

                label32:
                for(int i = 0; i < tableInfos.size(); ++i) {
                    TableInfo table = (TableInfo)SerializationUtils.fromJsonString(JSON.toJSONString(tableInfos.get(i)), TableInfo.class);
                    if (tableName.equalsIgnoreCase(table.getName())) {
                        JSONArray columns = table.getColumns();
                        int m = 0;

                        while(true) {
                            if (m >= columns.size()) {
                                break label32;
                            }

                            JSONObject col = columns.getJSONObject(m);
                            ComboItem item = new ComboItem();
                            item.setCaption(new LocaleString(col.getString("name") + "(" + col.getString("comment") + ")"));
                            item.setValue(col.getString("name"));
                            items.add(item);
                            ++m;
                        }
                    }
                }

                combo_Field.setComboItems(items);
            }
        }
    }

    private void propertyChanged_AppOjb() {
        this.getModel().setValue("formobjectlist", "");
    }

    private void propertyChanged_FormObj() {
        ComboEdit combo_Table = (ComboEdit)this.getControl("formtables");
        ComboEdit combo_Field = (ComboEdit)this.getControl("tablefields");
        List<ComboItem> items = new ArrayList();
        combo_Table.setComboItems(items);
        combo_Field.setComboItems(items);
        this.getModel().setValue("formtables", "");
        this.getModel().setValue("tablefields", "");
        if (this.getModel().getValue("formobject") != null) {
            DynamicObject dym = (DynamicObject)this.getModel().getValue("formobject");
            String formNumber = dym.getString("number");
            String formType = dym.getString("modeltype");
            String dbRoutKey = MetadataUtil.getDBRoutKeyByFormNumber(formNumber);
            String entityId = MetadataDao.getIdByNumber(formNumber, MetaCategory.Entity);
            String data = ErDataGenerator.getErdData(entityId, formNumber, dbRoutKey, "", (IPageCache)null);
            if (!StringUtils.isEmpty(data)) {
                JSONObject dataJson = JSONObject.parseObject(data);
                JSONArray tableArray = dataJson.getJSONObject("table").getJSONArray("tables");
                List<JSONObject> tableInfos = (List)SerializationUtils.fromJsonString(tableArray.toJSONString(), List.class);

                for(int i = 0; i < tableInfos.size(); ++i) {
                    TableInfo table = (TableInfo)SerializationUtils.fromJsonString(JSON.toJSONString(tableInfos.get(i)), TableInfo.class);
                    if (StringUtils.isEmpty(formType) || !formType.equalsIgnoreCase("BaseFormModel") || !this.chkBaseDataSysTable(table.getName())) {
                        ComboItem item = new ComboItem();
                        String tabCaption = "";
                        if (StringUtils.isEmpty(table.getComment())) {
                            tabCaption = table.getName();
                        } else {
                            tabCaption = table.getComment() + "," + table.getName();
                        }

                        item.setCaption(new LocaleString(tabCaption));
                        item.setValue(table.getName());
                        items.add(item);
                    }
                }

                combo_Table.setComboItems(items);
            }
        }
    }

    private void createKSQL_FormOjbList() {
        if (this.getModel().getValue("appobject") == null) {
            this.getView().showTipNotification("请选择应用。");
        } else if (this.getModel().getValue("formobjectlist") == null) {
            this.getView().showTipNotification("请选择表单。");
        } else {
            this.getView().getPageCache().remove("errMsgCache");
            DynamicObjectCollection appsDym = (DynamicObjectCollection)this.getModel().getValue("formobjectlist");
            CodeEdit codeSQLshow = (CodeEdit)this.getView().getControl("ksqltext");
            codeSQLshow.setText("");
            StringBuilder sqlText = new StringBuilder();
            Iterator var4 = appsDym.iterator();

            while(var4.hasNext()) {
                DynamicObject dym = (DynamicObject)var4.next();
                DynamicObject app = dym.getDynamicObject("fbasedataid");
                String formNumber = app.getString("number");
                String formName = app.getString("name");
                String formType = app.getString("modeltype");
                String dbRoutKey = MetadataUtil.getDBRoutKeyByFormNumber(formNumber);
                String metaTableKSQL = this.getMetaTableKSQL(formNumber, formName, dbRoutKey, formType, "", "");
                sqlText.append(metaTableKSQL);
                sqlText.append("\r\n");
                sqlText.append("\r\n");
            }

            codeSQLshow.setText(sqlText.toString());
            this.getView().showSuccessNotification("执行完成。");
            this.showErrMsg();
        }
    }

    private void createKSQL(String addTableName, String addTableFields) {
        this.getView().getPageCache().remove("errMsgCache");
        if (this.getModel().getValue("formobject") == null) {
            this.getView().showTipNotification("请选择表单。");
        } else {
            DynamicObject dym = (DynamicObject)this.getModel().getValue("formobject");
            CodeEdit codeSQLshow = (CodeEdit)this.getView().getControl("ksqltext");
            codeSQLshow.setText("");
            String formNumber = dym.getString("number");
            String formName = dym.getString("name");
            String formType = dym.getString("modeltype");
            String dbRoutKey = MetadataUtil.getDBRoutKeyByFormNumber(formNumber);
            String metaTableKSQL = this.getMetaTableKSQL(formNumber, formName, dbRoutKey, formType, addTableName, addTableFields);
            codeSQLshow.setText(metaTableKSQL);
            if (!StringUtils.isEmpty(metaTableKSQL)) {
                this.getView().showSuccessNotification("执行完成。");
            }

            this.showErrMsg();
        }
    }

    private void showErrMsg() {
        String errMsgCache = this.getView().getPageCache().get("errMsgCache");
        if (!StringUtils.isEmpty(errMsgCache)) {
            errMsgCache = "您的表结构设计不符合金蝶苍穹定制化开发规范：\r\n" + errMsgCache;
            this.getView().showMessage(errMsgCache);
        }

    }

    private void putErrInfoToPageCache(String errMsg) {
        if (!StringUtils.isEmpty(errMsg)) {
            String errMsgCache = this.getView().getPageCache().get("errMsgCache");
            if (StringUtils.isEmpty(errMsgCache)) {
                errMsgCache = "";
            } else {
                errMsgCache = errMsgCache + "\r\n";
            }

            errMsgCache = errMsgCache + errMsg;
            this.getView().getPageCache().put("errMsgCache", errMsgCache);
        }
    }

    public String getMetaTableKSQL(String formNumber, String formName, String dbRoutKey, String formType, String addTableName, String addTableFields) {
        if (StringUtils.isEmpty(formNumber)) {
            return "";
        } else {
            String entityId = MetadataDao.getIdByNumber(formNumber, MetaCategory.Entity);
            String data = ErDataGenerator.getErdData(entityId, formNumber, dbRoutKey, "", (IPageCache)null);
            StringBuilder sqlText = new StringBuilder();
            if (StringUtils.isEmpty(data)) {
                sqlText.append(String.format("/** 【!!!警告!!!】%s!!! **/", String.format("表单%s,%s没有数据库表。", formNumber, formName)));
                sqlText.append("\r\n");
                return sqlText.toString();
            } else {
                boolean isAddFieldKsql = !StringUtils.isEmpty(addTableName) && !StringUtils.isEmpty(addTableFields);
                JSONObject dataJson = JSONObject.parseObject(data);
                JSONArray tableArray = dataJson.getJSONObject("table").getJSONArray("tables");
                List<JSONObject> tableInfos = (List)SerializationUtils.fromJsonString(tableArray.toJSONString(), List.class);
                sqlText.append(String.format("/** ======= 表单（%s，%s）表结构创建KSQL脚本，表单分库标识：%s ======= **/", formName, formNumber, dbRoutKey));
                sqlText.append("\r\n");

                for(int i = 0; i < tableInfos.size(); ++i) {
                    TableInfo table = (TableInfo)SerializationUtils.fromJsonString(JSON.toJSONString(tableInfos.get(i)), TableInfo.class);
                    if ((StringUtils.isEmpty(formType) || !formType.equalsIgnoreCase("BaseFormModel") || !this.chkBaseDataSysTable(table.getName())) && (!isAddFieldKsql || addTableName.equalsIgnoreCase(table.getName()))) {
                        if (i > 0) {
                            sqlText.append("\r\n");
                        }

                        sqlText.append(this.getTableKsql(table, dbRoutKey, addTableName, addTableFields));
                    }
                }

                return sqlText.toString();
            }
        }
    }

    private boolean chkBaseDataSysTable(String tableName) {
        if (StringUtils.isEmpty(tableName)) {
            return false;
        } else {
            return tableName.toLowerCase().endsWith("_r2") || tableName.toLowerCase().endsWith("_r3") || tableName.toLowerCase().endsWith("_u") || tableName.toLowerCase().endsWith("_usereg") || tableName.toLowerCase().endsWith("_exc");
        }
    }

    private String checkTableNameConventions(String tableName) {
        if (!StringUtils.isEmpty(tableName) && !ISVServiceHelper.isKingdeeISV()) {
            String prefix_conv = ("tk_" + ISVServiceHelper.getISVInfo().getId()).toLowerCase();
            return !tableName.toLowerCase().startsWith(prefix_conv) ? String.format("表%s命名不符合规范（tk_[isv]_【系统标识_名称】）", tableName) : "";
        } else {
            return "";
        }
    }

    private String checkTableNamePKConventions(String tableName, String pkName) {
        if (!StringUtils.isEmpty(tableName) && !StringUtils.isEmpty(pkName) && !ISVServiceHelper.isKingdeeISV()) {
            String prefix_conv = ("pk_" + ISVServiceHelper.getISVInfo().getId()).toLowerCase();
            return !pkName.toLowerCase().startsWith(prefix_conv) ? String.format("表%s主键%s命名不符合规范（pk_[isv]_【系统标识_名称】）", tableName, pkName) : "";
        } else {
            return "";
        }
    }

    private String checkTableNameIndexConventions(String tableName, String indexName) {
        if (!StringUtils.isEmpty(tableName) && !StringUtils.isEmpty(indexName) && !ISVServiceHelper.isKingdeeISV()) {
            String prefix_conv = ("idx_" + ISVServiceHelper.getISVInfo().getId()).toLowerCase();
            return !indexName.toLowerCase().startsWith(prefix_conv) ? String.format("表%s索引%s命名不符合规范（idx_[isv]_系统标识_表/表缩写_字段/字段缩写）", tableName, indexName) : "";
        } else {
            return "";
        }
    }

    private String checkColumnConventions(String tableName, JSONArray columns) {
        if (columns != null && !columns.isEmpty() && !ISVServiceHelper.isKingdeeISV()) {
            String columns_conv = "";
            String prefix_conv = ("fk_" + ISVServiceHelper.getISVInfo().getId()).toLowerCase();

            for(int i = 0; i < columns.size(); ++i) {
                JSONObject col = columns.getJSONObject(i);
                String colName = col.getString("name");

                try {
                    if (SystemFieldEnum.valueOf(colName.toUpperCase()) != null) {
                        continue;
                    }
                } catch (IllegalArgumentException var9) {
                    System.out.println("枚举不存在，需要校验命名规范");
                }

                if (!colName.toLowerCase().startsWith(prefix_conv)) {
                    columns_conv = columns_conv + (StringUtils.isEmpty(columns_conv) ? "" : ",") + colName;
                }
            }

            return !StringUtils.isEmpty(columns_conv) ? String.format("表%s的字段命名不规范：%s", tableName, columns_conv) : "";
        } else {
            return "";
        }
    }

    public String getTableKsql(TableInfo table, String dbRoutKey, String addTableName, String addTableFields) {
        if (table != null && !StringUtils.isEmpty(table.getName())) {
            DBRoute dbRoute = DBRoute.of(dbRoutKey == null ? "sys" : dbRoutKey);
            String tableName = table.getName();
            String tableComment = table.getComment();
            boolean isAddFieldKsql = !StringUtils.isEmpty(addTableName) && !StringUtils.isEmpty(addTableFields);
            if (isAddFieldKsql && !addTableName.equalsIgnoreCase(tableName)) {
                return "";
            } else {
                boolean altercolumn = (Boolean)this.getModel().getValue("altercolumn");
                StringBuilder sqlText = new StringBuilder();
                List<FieldInfo> tableFields = DB.getFieldInfo(dbRoute, tableName);
                JSONArray columns = table.getColumns();
                int i;
                String colName;
                String indexName;
                int m;
                if (columns != null && !columns.isEmpty()) {
                    String checkColumn;
                    if (!isAddFieldKsql) {
                        sqlText.append(String.format("/** 创建表 %s  **/", StringUtils.isEmpty(tableComment) ? tableName : tableComment));
                        sqlText.append("\r\n");
                        checkColumn = this.checkTableNameConventions(tableName);
                        if (!StringUtils.isEmpty(checkColumn)) {
                            this.putErrInfoToPageCache(checkColumn);
                            sqlText.append(String.format("/** 【!!!警告!!!】%s!!! **/", checkColumn));
                            sqlText.append("\r\n");
                            sqlText.append(String.format("/** 【定制化开发规范参考】%s **/", "https://vip.kingdee.com/link/s/lFga1"));
                            sqlText.append("\r\n");
                        }

                        sqlText.append(String.format("IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = '%s') ", tableName.toUpperCase()));
                        sqlText.append("\r\n");
                        sqlText.append(String.format("CREATE TABLE %s ( ", tableName.toUpperCase()));
                        sqlText.append("\r\n");
                    }

                    checkColumn = this.checkColumnConventions(tableName, columns);
                    if (!StringUtils.isEmpty(checkColumn)) {
                        this.putErrInfoToPageCache(checkColumn);
                        sqlText.append(String.format("/** 【!!!警告!!!】%s!!! **/", checkColumn));
                        sqlText.append("\r\n");
                        sqlText.append(String.format("/** 【定制化开发规范参考】%s **/", "https://vip.kingdee.com/link/s/lFga1"));
                        sqlText.append("\r\n");
                    }

                    for(i = 0; i < columns.size(); ++i) {
                        JSONObject col = columns.getJSONObject(i);
                        this.updColumn(col, tableFields);
                        colName = col.getString("name");
                        String colDataType = col.getString("dataType");
                        indexName = col.get("default") == null ? null : col.getString("default");
                        long dataLength = col.getLong("dataLength");
                        m = col.getInteger("dataPrecision");
                        int dataScale = col.getInteger("dataScale");
                        boolean nullable = col.getBoolean("nullable");
                        String ksqlDataType = this.getColumnDataType(colDataType, dataLength, m, dataScale);
                        String colDefaut = "";
                        if (!nullable && indexName != null) {
                            colDefaut = "DEFAULT " + indexName;
                        }

                        if (isAddFieldKsql) {
                            List<String> addFields = Arrays.asList(addTableFields.toLowerCase().split(","));
                            if (!addFields.contains(colName.toLowerCase())) {
                                continue;
                            }

                            String columnKSQL = "";
                            if (altercolumn) {
                                columnKSQL = String.format("EXEC p_AlterColumn '%s', '%s', '%s', '%s', '0111', '%s';", tableName, colName, ksqlDataType, !nullable ? "NOT NULL" : "NULL", indexName == null ? "null" : indexName.replace("'", "''"));
                            } else {
                                columnKSQL = String.format("IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = '%s' AND KSQL_COL_NAME ='%s')", tableName, colName);
                                sqlText.append(columnKSQL.toUpperCase());
                                sqlText.append("\r\n");
                                columnKSQL = String.format("  ALTER TABLE %s ADD (%s %s %s %s);", tableName, colName, ksqlDataType, colDefaut, !nullable ? "NOT NULL" : "NULL");
                            }

                            sqlText.append(columnKSQL.toUpperCase());
                        } else {
                            String columnKSQL = String.format("  %s %s %s %s", colName, ksqlDataType, colDefaut, !nullable ? "NOT NULL" : "NULL");
                            if (i < columns.size() - 1) {
                                columnKSQL = columnKSQL + ",";
                            }

                            sqlText.append(columnKSQL.toUpperCase());
                        }

                        sqlText.append("\r\n");
                    }

                    if (!isAddFieldKsql) {
                        sqlText.append(");");
                        sqlText.append("\r\n");
                    }
                } else {
                    sqlText.append(String.format("/** 【!!!警告!!!】表 %s 在数据库不存在，请先在数据库创建表!!! **/", tableName));
                    sqlText.append("\r\n");
                }

                if (!isAddFieldKsql) {
                    List<String> pkList = DB.getPrimaryKeys(dbRoute, tableName);
                    if (pkList != null && !pkList.isEmpty()) {
                        sqlText.append(String.format("/** 创建表 %s 主键 **/", StringUtils.isEmpty(tableComment) ? tableName : tableComment));
                        sqlText.append("\r\n");

                        for(i = 0; i < pkList.size(); ++i) {
                            String pkColumns = (String)pkList.get(i);
                            colName = String.format("EXEC P_ALTERPK 'PK_%s_%d', '%s', '%s', '0';", tableName, i + 1, tableName, pkColumns);
                            sqlText.append(colName.toUpperCase());
                            sqlText.append("\r\n");
                        }
                    } else {
                        this.putErrInfoToPageCache(String.format("表 %s 未创建主键", tableName));
                        sqlText.append(String.format("/** 【!!!警告!!!】表 %s 未创建主键!!! **/", tableName));
                        sqlText.append("\r\n");
                    }

                    sqlText.append("\r\n");
                    List<IndexInfo> indexInfos = DB.getIndexInfo(dbRoute, tableName);
                    boolean noIndex = true;
                    if (indexInfos != null && !indexInfos.isEmpty()) {
                        for(int j = 0; j < indexInfos.size(); ++j) {
                            IndexInfo indexInfo = (IndexInfo)indexInfos.get(j);
                            indexName = indexInfo.getIndexName();
                            List<IndexInfo.IndexFieldInfo> indexFields = indexInfo.getIndexFieldInfo();
                            String indexField = "";

                            String createIndexKsql;
                            for(m = 0; m < indexFields.size(); ++m) {
                                IndexInfo.IndexFieldInfo inf = (IndexInfo.IndexFieldInfo)indexFields.get(m);
                                createIndexKsql = inf.getFieldName();
                                indexField = indexField + (StringUtils.isEmpty(indexField) ? "" : ",") + createIndexKsql;
                            }

                            if (!pkList.contains(indexField)) {
                                if (noIndex) {
                                    sqlText.append(String.format("/** 创建表 %s 索引 **/", StringUtils.isEmpty(tableComment) ? tableName : tableComment));
                                    sqlText.append("\r\n");
                                    noIndex = false;
                                }

                                String checkIndexName = this.checkTableNameIndexConventions(tableName, indexName);
                                if (!StringUtils.isEmpty(checkIndexName)) {
                                    this.putErrInfoToPageCache(checkIndexName);
                                    sqlText.append(String.format("/** 【!!!警告!!!】%s !!! **/", checkIndexName));
                                    sqlText.append("\r\n");
                                    sqlText.append(String.format("/** 【定制化开发规范参考】%s **/", "https://vip.kingdee.com/link/s/lFga1"));
                                    sqlText.append("\r\n");
                                }

                                String unIndex = "";
                                if (tableName.toUpperCase().endsWith("_L") && indexField.equalsIgnoreCase("FID,FLOCALEID")) {
                                    unIndex = "UNIQUE CLUSTERED";
                                }

                                createIndexKsql = String.format("IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = '%s') \r\n  CREATE %s INDEX %s ON %s (%s);", indexName, unIndex, indexName, tableName, indexField);
                                sqlText.append(createIndexKsql.toUpperCase());
                                sqlText.append("\r\n");
                            }
                        }
                    }

                    if (noIndex) {
                        this.putErrInfoToPageCache(String.format("表 %s 未创建索引", tableName));
                        sqlText.append(String.format("/** 【!!!警告!!!】表 %s 未创建索引!!! **/", tableName));
                        sqlText.append("\r\n");
                    }
                }

                return sqlText.toString();
            }
        } else {
            return "";
        }
    }

    private void updColumn(JSONObject column, List<FieldInfo> tableFields) {
        if (tableFields != null && !tableFields.isEmpty()) {
            String colName = column.getString("name");

            for(int i = 0; i < tableFields.size(); ++i) {
                FieldInfo field = (FieldInfo)tableFields.get(i);
                if (colName.equalsIgnoreCase(field.getFieldName())) {
                    column.put("dataLength", field.getDataLength());
                    column.put("dataPrecision", field.getDataPrecision());
                    column.put("dataScale", field.getDataScale());
                    column.put("nullable", field.isNullable());
                    break;
                }
            }

        }
    }

    private String getColumnDataType(String dataType, long dataLength, int dataPrecision, int dataScale) {
        if (StringUtils.isEmpty(dataType)) {
            return "";
        } else {
            String ksqlDataType = "";
            switch (dataType.toLowerCase()) {
                case "int8":
                case "bigint":
                    ksqlDataType = "BIGINT";
                    break;
                case "int4":
                case "int":
                    ksqlDataType = "INT";
                    break;
                case "smallint":
                    ksqlDataType = "SMALLINT";
                    break;
                case "bpchar":
                case "varchar":
                    ksqlDataType = "varchar(" + dataLength + ")";
                    break;
                case "nvarchar":
                    ksqlDataType = "nvarchar(" + dataLength + ")";
                    break;
                case "char":
                    ksqlDataType = "char(" + dataLength + ")";
                    break;
                case "nchar":
                    ksqlDataType = "nchar(" + dataLength + ")";
                    break;
                case "numeric":
                case "decimal":
                    ksqlDataType = "DECIMAL(" + dataPrecision + "," + dataScale + ")";
                    break;
                case "timestamp":
                case "datetime":
                case "date":
                    ksqlDataType = "DATETIME";
                    break;
                case "bytea":
                case "blob":
                case "image":
                    ksqlDataType = "BLOB";
                    break;
                case "text":
                case "ntext":
                case "nclob":
                    ksqlDataType = "NCLOB";
                    break;
                default:
                    ksqlDataType = dataType;
            }

            return ksqlDataType;
        }
    }
}