package q1k2.base.common.ceco.plugin.formplugin;

import kd.bos.cache.CacheFactory;
import kd.bos.cache.TempFileCache;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.IPageCache;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.Button;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.util.FileNameUtils;

import java.io.InputStream;
import java.util.*;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.ceco.plugin.formplugin
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  18:24
 * @Description: TODO
 * @Version: 1.0
 */
public class UploadExcelFormPlugin extends AbstractFormPlugin {
    private static final String BTNOK = "btnok";
    private static final String ATTACHMENTPANELAP = "attachmentpanelap";

    public UploadExcelFormPlugin() {
    }

    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
    }

    public void click(EventObject evt) {
        super.click(evt);
        String controlName = "";
        if (evt.getSource() instanceof Button) {
            controlName = ((Button)evt.getSource()).getKey();
        }

        switch (controlName) {
            case "btnok":
                this.click_ok();
            default:
        }
    }

    private void click_ok() {
        if (this.isHaveAttachment()) {
            this.getView().showTipNotification("请先上传Excel模板文件。");
        } else if (this.hasAttachmentUploading()) {
            this.getView().showTipNotification("Excel模板文件上传中，请稍后再试。");
        } else {
            AttachmentPanel attachmentPanel = (AttachmentPanel)this.getView().getControl("attachmentpanelap");
            List<Map<String, Object>> attachmentData = attachmentPanel.getAttachmentData();
            if (attachmentData != null && !attachmentData.isEmpty()) {
                Map<String, Object> tempAtta = (Map)attachmentData.get(0);
                String attname = (String)tempAtta.get("name");
                String atturl = (String)tempAtta.get("url");
                String tempfile = this.uploadTempfile(atturl, attname);
                HashMap<String, String> hashMap = new HashMap();
                hashMap.put("tempfile", tempfile);
                this.getView().returnDataToParent(hashMap);
                this.getView().close();
            } else {
                this.getView().showTipNotification("请先上传Excel模板文件。");
            }
        }
    }

    private String uploadTempfile(String url, String name) {
        TempFileCache cache = CacheFactory.getCommonCacheFactory().getTempFileCache();
        InputStream in = cache.getInputStream(url);
        FileService service = FileServiceFactory.getAttachmentFileService();
        RequestContext requestContext = RequestContext.get();
        String uuid = UUID.randomUUID().toString().replace("-", "");
        String pathParam = FileNameUtils.getAttachmentFileName(requestContext.getTenantId(), requestContext.getAccountId(), uuid, name);
        FileItem fileItem = new FileItem(name, pathParam, in);
        String downUrl = service.upload(fileItem);
        return downUrl;
    }

    private boolean hasAttachmentUploading() {
        IPageCache cache = (IPageCache)this.getView().getService(IPageCache.class);
        String uploadingAttJson = cache.get("UploadingAtt" + this.getView().getPageId());
        return StringUtils.isNotBlank(uploadingAttJson);
    }

    private boolean isHaveAttachment() {
        AttachmentPanel panel = (AttachmentPanel)this.getView().getControl("attachmentpanelap");
        List<Map<String, Object>> attachmentData = panel.getAttachmentData();
        return attachmentData.isEmpty();
    }
}
