package q1k2.base.common.utils;

import java.util.*;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.utils
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  17:41
 * @Description: TODO
 * @Version: 1.0
 */
public class ComPreExtractorUtil {
    public ComPreExtractorUtil() {
    }

    public static String getCommonPrefixs(List<String> strings) {
        if (strings != null && !strings.isEmpty()) {
            Map<String, List<String>> groupedPaths = new HashMap();

            String path;
            String firstLevelDir;
            for (Iterator var2 = strings.iterator(); var2.hasNext(); ((List) groupedPaths.get(firstLevelDir)).add(path)) {
                path = (String) var2.next();
                firstLevelDir = path.split("\\.")[0];
                if (!groupedPaths.containsKey(firstLevelDir)) {
                    groupedPaths.put(firstLevelDir, new ArrayList());
                }
            }

            StringBuilder sb = new StringBuilder();
            Iterator var6 = groupedPaths.entrySet().iterator();

            while (var6.hasNext()) {
                Map.Entry<String, List<String>> entry = (Map.Entry) var6.next();
                sb.append(getCommonPrefix((List) entry.getValue()));
                sb.append("\n");
            }

            if (sb.length() > 0 && sb.charAt(sb.length() - 1) == '\n') {
                sb.deleteCharAt(sb.length() - 1);
            }

            return sb.toString();
        } else {
            return "";
        }
    }

    public static String getCommonPrefix(List<String> strings) {
        strings.sort(String::compareTo);
        String firstString = (String) strings.get(0);
        String lastString = (String) strings.get(strings.size() - 1);
        int minLength = Math.min(firstString.length(), lastString.length());
        int commonPrefixLength = 0;

        for (int i = 0; i < minLength && firstString.charAt(i) == lastString.charAt(i); ++i) {
            ++commonPrefixLength;
        }

        String comPreStr = firstString.substring(0, commonPrefixLength);
        return removeTrailingDot(comPreStr);
    }

    private static String removeTrailingDot(String str) {
        return str.endsWith(".") ? str.substring(0, str.length() - 1) : str;
    }
}
