package q1k2.base.common.utils;

import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.metadata.dao.MetaCategory;
import kd.bos.metadata.dao.MetadataDao;
import kd.bos.metadata.entity.EntityMetadata;

/**
 * @BelongsProject: q1k2-cosmic
 * @BelongsPackage: q1k2.base.common.utils
 * @Author: yanhongwei
 * @CreateTime: 2024-06-26  17:43
 * @Description: TODO
 * @Version: 1.0
 */
public class MetadataUtil {

        protected static final Log log = LogFactory.getLog(MetadataUtil.class);

        public MetadataUtil() {
        }

        public static String getDBRoutKeyByFormNumber(String formNumber) {
            if (StringUtils.isEmpty(formNumber)) {
                return "";
            } else {
                MainEntityType entityType = EntityMetadataCache.getDataEntityType(formNumber);
                String routKey = entityType.getDBRouteKey();
                if (StringUtils.isBlank(routKey)) {
                    String entityId = MetadataDao.getIdByNumber(formNumber, MetaCategory.Entity);
                    EntityMetadata oldEntityMeta = (EntityMetadata)MetadataDao.readMeta(entityId, MetaCategory.Entity);
                    routKey = oldEntityMeta.getDBRouteKey();
                }

                return routKey;
            }
        }
}
